<script type="text/javascript">
	function doInject(node, customMsg) {
		//console.log("doInject: " + JSON.stringify(customMsg));
		$.ajax({
			url: "xkeys_setunitid_inject/" + node.id,
			type: "POST",
			data: JSON.stringify(customMsg),
			contentType: "application/json; charset=utf-8"
		});
	}
    RED.nodes.registerType('xkeys_setunitid',{
        category: 'Xkeys',
        color: '#5dc8f4',
        defaults: {
            newname: {value:"X-keys Set Unit ID"},
            name: {value:""},
			pidOptions: {value: []},        // Property for user selected devices
			quad_list: {value: [],
				validate:function(v){
					return (v.length < 2);
				}
			},
			new_unit_id: {value:"",
				validate:function(v){
					return (-1 < parseInt(v) && parseInt(v) < 256 && v != this.unit_id && this.valid_target);
				}
			},
			valid_target:{value:true},
        },
		button: {
			onclick: function() {
				// Called when the button is clicked
				//console.log("click");

				// Post new unit_id to js
				doInject(this, {payload:{new_unit_id:this.new_unit_id}});
			},
			visible: function() {
				//return (this.quad_list.length==1);
				return (this.valid_target);
			}
		},
        inputs:0,
        outputs:0,
        icon: "X-keysXicon.png",
        label: function() {
            return this.name||this.newname||"X-keys Set Unit ID";
        },
		labelStyle: function () {
			return this.newname?"node_label_italic":"";
		},
		paletteLabel: "xk Set Unit ID",
		align: 'right',
		oneditprepare: function() {
			const parentDiv =  $("#dialog-form"); // <<make sure this selects YOUR nodes DIV
			var inputNo = 1;
			$.getJSON('xkeys_setunitid/devices', function(device_data) {
				var devs = device_data.devices;
				var pidOptions = device_data.pidOptions;
				var quad_list = device_data.quad_list;
				if (devs.length == 0) {
					//console.log(`No devices`);

					var myNewRow = $('<div class="form-row" />');
					parentDiv.append(myNewRow);
					var myNewLabel = $(`<label for="node-input-advice"><i class="fa fa-exclamation-circle"></i> Suggestion!</label>`);
					var myNewInput = $(`<input type="text" id="node-input-advice" placeholder="Press Deploy button to see available devices"/>`);
					myNewRow.append(myNewLabel);
					myNewRow.append(myNewInput);

					return;
				}
				devs.forEach( (device) => {
					//console.log(`Setting up: ${device.name}`);

					var inputID = "node-input-setunitid-dynamic-" + inputNo; // for generating dynamic ID
					var myNewRow = $('<div class="form-row" />');
					parentDiv.append(myNewRow);
					var myNewInput = $(`<input type="checkbox" class="setunitid-dynamic-element" id="${inputID}" style="width:64px;" data-quad="${device.device_quad}" data-name="${device.name}" />`);
					var myNewLabel = $(`<label for="${inputID}" style="width:360px;"><i class="fa fa-globe"></i> ${device.device_quad},  ${device.name}</label>`);
					myNewRow.append(myNewLabel);
					myNewRow.append(myNewInput);

					// If this device was seen previously (same device_quad), set its 'checked' status
					var matchedInputID = pidOptions.find((entry) => entry.device_quad == device.device_quad);
					if (matchedInputID) {
						$(`#${inputID}`).prop('checked', matchedInputID.checked);
					}

					inputNo++;
				});



				var new_unit_id_options = [];
				for (var i=1;i<256;i++) {
					new_unit_id_options.push({ label: i.toString(), value:  i.toString()});
				}
				$("#node-input-newid").typedInput({
					types: [{
						value: "new_unit_id",
						options: new_unit_id_options
					}]
				});
			});
		},
		oneditsave: function () {
			// Construct label based on configured options
			this.newname = "X-keys Set Unit ID";

			var dynamicElements = $(".setunitid-dynamic-element");  // same class name as used for the dynamic DOM elements above
			var dynOpts = [];
			var quadList = [];dynamicElements.each( function(index,el) {
				var name = $(el).data("name"); //get value of data-name from the dynamic element
				var device_quad = $(el).data("quad"); //get value of data-device_quad from the dynamic element
				var checked = $(el).is(":checked"); //get checked true/false from the dynamic element
				var opt = {
					name: name,
					device_quad: device_quad,
					checked: checked
				}
				dynOpts.push(opt);
				if (checked) { quadList.push(device_quad); }
			});
			this.pidOptions = dynOpts; //update the node prop `pidOptions`
			this.quad_list = quadList;



			//console.log(`new_unit_id = ${this.new_unit_id}`);
			//console.log(`quad_list = ${JSON.stringify(this.quad_list)}`);
			//console.log(`node-input-new_unit_id = ${$("#node-input-new_unit_id").val()}`);

			/* Warn of potential problems
			*/
			const sins = [];
			const new_unit_id = $("#node-input-new_unit_id").val();
			if (!new_unit_id) {
				console.log(`no new_unit_id is set`);
				sins.push("<br>New Unit ID is not set. Please set it.<br>");
			}
			else {
				const new_unit_id_number = parseInt(new_unit_id);
				if (quadList.find( (opt) => parseInt(new_unit_id) == parseInt(opt.split("-")[2])) )
				{
					console.log(`new_unit_id already exists`);
					sins.push("<br>New Unit ID duplicates existing Unit ID. Please set a new Unit ID.<br>");
				}
				if ((new_unit_id_number < 0) || (new_unit_id_number > 255)) {
					console.log(`new_unit_id (${new_unit_id_number}) out of range`);
					sins.push("<br>New Unit ID should be in range 0-255<br>");
				}
			}
			if (quadList.length == 0) {
				console.log(`No device selected`);
				sins.push("<br>No device has been selected. Please select an available device.<br>");
			} else if (!(quadList.length == 1)) {
				console.log(`Multiple devices selected`);
				sins.push("<br>Only a single device should be selected. Please select 1 only.<br>");
			}
			if (quadList.length == 1) {
				this.newname = dynOpts.find( (dev) => dev.device_quad == quadList[0]).name + " Set Unit ID ";
			}

			if (sins.length > 0) {
				this.valid_target = false;
				var notify_text = "";
				sins.forEach( (line) => {
					notify_text += line;
				});
				var myNotification = RED.notify( notify_text, {
					modal: true,
					fixed: true,
					type: 'warning',
					buttons: [
						{
							text: RED._("common.label.ok"),
							click: function(e) {
								myNotification.close();
							}
						}
					]
				});
			} else {
				this.valid_target = true;
			}
		}
    });
</script>


<script type="text/html" data-template-name="xkeys_setunitid">
	<div class="form-row">
		<label for="node-input-new_unit_id"><i class="fa fa-dot-circle-o"></i> New Unit ID</label>
		<input type="text" id="node-input-new_unit_id" placeholder="Not set">
	</div>
    <div class="form-row">
        <label for="node-input-name"><i class="fa fa-tag"></i> Label</label>
        <input type="text" id="node-input-name" placeholder="Auto">
    </div>
</script>

<script type="text/html" data-help-name="xkeys_setunitid">
    <p>A node to process xkeys events</p>
</script>


